# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Union
from .. import utilities, tables


class Table(pulumi.CustomResource):
    acls: pulumi.Output[list]
    """
    One or more `acl` blocks as defined below.

      * `access_policies` (`list`) - An `access_policy` block as defined below.
        * `expiry` (`str`) - The ISO8061 UTC time at which this Access Policy should be valid until.
        * `permissions` (`str`) - The permissions which should associated with this Shared Identifier.
        * `start` (`str`) - The ISO8061 UTC time at which this Access Policy should be valid from.

      * `id` (`str`) - The ID which should be used for this Shared Identifier.
    """
    name: pulumi.Output[str]
    """
    The name of the storage table. Must be unique within the storage account the table is located.
    """
    storage_account_name: pulumi.Output[str]
    """
    Specifies the storage account in which to create the storage table.
    Changing this forces a new resource to be created.
    """
    def __init__(__self__, resource_name, opts=None, acls=None, name=None, storage_account_name=None, __props__=None, __name__=None, __opts__=None):
        """
        Manages a Table within an Azure Storage Account.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_azure as azure

        example_resource_group = azure.core.ResourceGroup("exampleResourceGroup", location="West Europe")
        example_account = azure.storage.Account("exampleAccount",
            resource_group_name=example_resource_group.name,
            location=example_resource_group.location,
            account_tier="Standard",
            account_replication_type="LRS")
        example_table = azure.storage.Table("exampleTable", storage_account_name=example_account.name)
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[list] acls: One or more `acl` blocks as defined below.
        :param pulumi.Input[str] name: The name of the storage table. Must be unique within the storage account the table is located.
        :param pulumi.Input[str] storage_account_name: Specifies the storage account in which to create the storage table.
               Changing this forces a new resource to be created.

        The **acls** object supports the following:

          * `access_policies` (`pulumi.Input[list]`) - An `access_policy` block as defined below.
            * `expiry` (`pulumi.Input[str]`) - The ISO8061 UTC time at which this Access Policy should be valid until.
            * `permissions` (`pulumi.Input[str]`) - The permissions which should associated with this Shared Identifier.
            * `start` (`pulumi.Input[str]`) - The ISO8061 UTC time at which this Access Policy should be valid from.

          * `id` (`pulumi.Input[str]`) - The ID which should be used for this Shared Identifier.
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = dict()

            __props__['acls'] = acls
            __props__['name'] = name
            if storage_account_name is None:
                raise TypeError("Missing required property 'storage_account_name'")
            __props__['storage_account_name'] = storage_account_name
        super(Table, __self__).__init__(
            'azure:storage/table:Table',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name, id, opts=None, acls=None, name=None, storage_account_name=None):
        """
        Get an existing Table resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param str id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[list] acls: One or more `acl` blocks as defined below.
        :param pulumi.Input[str] name: The name of the storage table. Must be unique within the storage account the table is located.
        :param pulumi.Input[str] storage_account_name: Specifies the storage account in which to create the storage table.
               Changing this forces a new resource to be created.

        The **acls** object supports the following:

          * `access_policies` (`pulumi.Input[list]`) - An `access_policy` block as defined below.
            * `expiry` (`pulumi.Input[str]`) - The ISO8061 UTC time at which this Access Policy should be valid until.
            * `permissions` (`pulumi.Input[str]`) - The permissions which should associated with this Shared Identifier.
            * `start` (`pulumi.Input[str]`) - The ISO8061 UTC time at which this Access Policy should be valid from.

          * `id` (`pulumi.Input[str]`) - The ID which should be used for this Shared Identifier.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = dict()

        __props__["acls"] = acls
        __props__["name"] = name
        __props__["storage_account_name"] = storage_account_name
        return Table(resource_name, opts=opts, __props__=__props__)

    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop
